> ## Documentation Index
> Fetch the complete documentation index at: https://docs.amberdata.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Events/Updates Historical

> Provides historical updates to Spot market order books, capturing real-time changes in bid and ask levels, volumes, and order counts for specified trading pairs, with precise timestamps for event sequencing and tracking market activity.

<Accordion title="BitMEX Volume Calculation Warning">
  <Warning>
    BitMEX’s `volume` field represents the **number of contracts traded**, not the volume in the base asset.

    To obtain the correct volume, users must adjust for **contract size** using the `underlyingToPositionMultiplier` from our [Reference endpoint](/http/md/spot-exchanges-reference).

    For details on this calculation and how to retrieve the correct values, see our [Changelog Update](/changelog/bitmex-volume-mapping).
  </Warning>
</Accordion>

<Warning>
  The maximum time range (difference between `startDate` and `endDate`) is **18 months**.
</Warning>

<Note>
  If the `startDate` and `endDate` query parameters are not provided, the API will return the data from the previous 24 hours.
</Note>


## OpenAPI

````yaml get /spot/order-book-events/{instrument}
openapi: 3.1.0
info:
  title: market-api
  version: '2'
servers:
  - url: https://api.amberdata.com/markets
security:
  - ApiKeyAuth: []
paths:
  /spot/order-book-events/{instrument}:
    get:
      summary: Events/Updates Historical
      description: >-
        Provides historical updates to Spot market order books, capturing
        real-time changes in bid and ask levels, volumes, and order counts for
        specified trading pairs, with precise timestamps for event sequencing
        and tracking market activity.
      operationId: spot-order-book-events
      parameters:
        - name: instrument
          in: path
          description: The spot instrument for which data will be retrieved.
          schema:
            type: string
            default: btc_usd
          required: true
        - name: exchange
          in: query
          description: >-
            The exchange for which data should be retrieved. Only **1** exchange
            is allowed.
          required: true
          schema:
            type: string
            default: gdax
        - name: startDate
          in: query
          description: >-
            **[Optional]** Payload only includes data after this date
            (inclusive).  **[Formats]** `seconds | milliseconds | iso8601`
            **[Examples]** `1578531600 | 1578531600000 | 2020-09-01T01:00:00`
          schema:
            type: string
            format: date-time
            default: '2024-03-01T00:00:00'
        - name: endDate
          in: query
          description: >-
            **[Optional]** Payload only includes data before this date
            (exclusive).  **[Formats]** `seconds | milliseconds | iso8601`
            **[Examples]** `1578531600 | 1578531600000 | 2020-09-01T01:00:00`
          schema:
            type: string
            format: date-time
            default: '2024-03-01T01:00:00'
        - name: timeFormat
          in: query
          description: '**[Optional]** Time format of the timestamps in the response.'
          schema:
            type: string
            enum:
              - milliseconds
              - ms*
              - iso
              - iso8601
              - hr
              - human_readable
            default: hr
        - name: sortDirection
          in: query
          description: >-
            **[Optional]** Specifies the direction in which the data is sorted
            (by timestamp).   **[Defaults]** asc (ascending order).   **[Usage
            Conditions]** This parameter can only be used if the `startDate` and
            `endDate` timeframe is within the most recent 24 hours, or if the
            `startDate` and `endDate` parameters are not used at all.  
            **[Examples]** ascending | descending | asc | desc
          schema:
            type: string
        - name: Accept-Encoding
          in: header
          required: true
          description: ''
          schema:
            type: string
            default: gzip, deflate, br
        - name: api-version
          in: header
          schema:
            type: string
      responses:
        '200':
          description: '200'
          content:
            application/json:
              examples:
                Result:
                  value:
                    status: 200
                    title: OK
                    description: Successful request
                    payload:
                      metadata:
                        requestedStartDate: 2024-03-01 00:00:00 000
                        returnedStartDate: 2024-03-01 00:00:00 005
                        returnedEndDate: 2024-03-01 00:00:42 218
                        next: >-
                          https://api.amberdata.com/markets/spot/order-book-events/btc_usd?cursor=N4IgxgrgTgzg9lEAuAdhANugNCGAXAQyjwBEC8BTZARgHYAGATgCYBWa5gFmeeoA4cFFABMylGgxatOfenLk48ASwC2FAGIIV5ZCAAWEbSgBKFAsIIAjdFUWqKASRSUoANwLpkoFATW6AnmawIDgwAI7oAHK%2BVEgggUQhuBHRagAK6NAeAUHo-knCFABmBBh4yHwAbJzyCiDaAB7IlQDMXDK19DjocHAA1pYEYH1pFFBKcMLIaJgAvjhFWjpxAFbwKEkUDWB6BCgA5rEg%2BxZNOEooYJmFAKooMBAADo8IlMIAotu7BxQwyCXoGAUUKEYjRFBwIFgOAiP5IRjyboEfAAcSgcCeXhAF3wUEMQnKcUseDAAH0IDApoIvntDroTgQziAtjtaRQACr2fC%2BR66Zj0LgAWnoLWF1AABHIkFLuOLeHxNjSfpy1NyVI9wZCKNDYcgEXUgWEIEIwEdOLQ%2BMxKsxaC1aPLLYwksi%2BsgANqgR7jU3NDjURgAOk4rBwrjgmT80pwaBUAHkoIVgqgMOhZgBdHCWJRTJButOzWZAA
                        api-version: '2023-09-30'
                      data:
                        - instrument: btc_usd
                          exchange: gdax
                          exchangeTimestamp: 2024-03-01 00:00:00 005
                          exchangeTimestampNanoseconds: 174000
                          sequence: '478262695005780'
                          ask: []
                          bid:
                            - price: 61141.86
                              volume: 0
                              numOrders: null
                        - instrument: btc_usd
                          exchange: gdax
                          exchangeTimestamp: 2024-03-01 00:00:00 005
                          exchangeTimestampNanoseconds: 174000
                          sequence: '478262695005781'
                          ask: []
                          bid:
                            - price: 61099.03
                              volume: 0
                              numOrders: null
              schema:
                type: object
                properties:
                  status:
                    type: integer
                  title:
                    type: string
                  description:
                    type: string
                  payload:
                    type: object
                    properties:
                      metadata:
                        type: object
                        properties:
                          requestedStartDate:
                            type: string
                          returnedStartDate:
                            type: string
                          returnedEndDate:
                            type: string
                          next:
                            type: string
                          api-version:
                            type: string
                      data:
                        type: array
                        items:
                          type: object
                          properties:
                            instrument:
                              type: string
                            exchange:
                              type: string
                            exchangeTimestamp:
                              type: string
                            exchangeTimestampNanoseconds:
                              type: integer
                            sequence:
                              type: string
                            ask:
                              type: array
                              items: {}
                            bid:
                              type: array
                              items:
                                type: object
                                properties:
                                  price:
                                    type: number
                                  volume:
                                    type: integer
                                  numOrders:
                                    type: string
      deprecated: false
      security:
        - ApiKeyAuth: []
components:
  securitySchemes:
    ApiKeyAuth:
      type: apiKey
      in: header
      name: x-api-key

````